unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    PaintBox1: TPaintBox;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    Bmp: TBitmap;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    ClipBrd, Math;

//=============================================================================

//-----------------------------------------------------------------------------
//  l
//  http://homepage3.nifty.com/ishidate/vcpp6_g8/vcpp6_g8.htm
procedure Monochromize(Src, Dst: TBitmap; Threshold: integer = 180);
var
    i, j: integer;
    LineS, LineD: PByteArray;
    R, G, B, Gray: Byte;
    Check: integer;
begin
    Dst.Width := Src.Width;
    Dst.Height := Dst.Height;

    for i := 0 to Src.Height - 1 do
    begin
        //  1se
        LineS := Src.ScanLine[i];
        LineD := Dst.ScanLine[i];

        for j := 0 to Src.Width - 1 do
        begin
            //  RGBlꂼo
            R := LineS[j * 3 + 2];
            G := LineS[j * 3 + 1];
            B := LineS[j * 3 + 0];

            //  
            Check := 2 * R + 4 * G + B;
            Gray := 0;
            if (Check > Threshold * 7) then Gray := 255;

            //  RGBlꂼꏑ
            LineD[j * 3 + 2] := Gray;
            LineD[j * 3 + 1] := Gray;
            LineD[j * 3 + 0] := Gray;
        end;
    end;
end;

//=============================================================================

//-----------------------------------------------------------------------------
//  摜㉺E1sNZg(㉺2sNZ/E2sNZ)
//  gsNZɂ͌摜̒[Rs[(gӏɂ͍[Rs[)
procedure Expand(Bmp: TBitmap);
var
    SrcW, SrcH: integer;
begin
    SrcW := Bmp.Width;
    SrcH := Bmp.Height;

    //  E̕L
    Bmp.Width := SrcW + 2;

    //  ㉺̕L
    Bmp.Height := SrcH + 2;

    //  E1sNZ炷
    BitBlt(Bmp.Canvas.Handle, 1, 1, SrcW, SrcH, Bmp.Canvas.Handle,
           0, 0, SRCCOPY);

    //  ċ󔒂ɂȂ𖄂߂Ă

    //  [
    BitBlt(Bmp.Canvas.Handle, 0, 0, 1, Bmp.Height,
        Bmp.Canvas.Handle, 1, 0, SRCCOPY);

    //  E[
    BitBlt(Bmp.Canvas.Handle, Bmp.Width - 1, 0, 1, Bmp.Height,
        Bmp.Canvas.Handle, Bmp.Width - 2, 0, SRCCOPY);

    //  [
    BitBlt(Bmp.Canvas.Handle, 0, 0, Bmp.Width, 1,
        Bmp.Canvas.Handle, 0, 1, SRCCOPY);

    //  [
    BitBlt(Bmp.Canvas.Handle, 0, Bmp.Height - 1, Bmp.Width, 1,
        Bmp.Canvas.Handle, 0, Bmp.Height - 2, SRCCOPY);

    //  
    Bmp.Canvas.Pixels[0, 0] := Bmp.Canvas.Pixels[1, 1]; 

    //  E
    Bmp.Canvas.Pixels[Bmp.Width - 1, 0] := Bmp.Canvas.Pixels[Bmp.Width - 2, 1];

    //  
    Bmp.Canvas.Pixels[0, Bmp.Height - 1] := Bmp.Canvas.Pixels[1, Bmp.Height - 2];

    //  E
    Bmp.Canvas.Pixels[Bmp.Width - 1, Bmp.Height - 1] := Bmp.Canvas.Pixels[Bmp.Width - 2, Bmp.Height - 2];
end;

//-----------------------------------------------------------------------------
//  Edgeô߂Operator̐ݒ
type
    TOperator = array[0..2, 0..2] of Integer;

const
    Roberts: TOperator = ((0,0,0), (0,1,0), (-1,0,0));
    Prewitt: TOperator = ((1,1,1), (0,0,0), (-1,-1,-1));
    Sobel  : TOperator = ((1,2,1), (0,0,0), (-1,-2,-1));

//-----------------------------------------------------------------------------
//  Edge̋̍ől߂
type
    TWordWordArray = array of array of Word;

function MaxValue(const WwArray: TWordWordArray): Word;
var
    i, j: integer;
begin
    Result := 0;
    for i := 0 to Length(WwArray) - 1 do
    begin
        for j := 0 to Length(WwArray[i]) - 1 do
        begin
            if WwArray[i][j] > Result then Result := WwArray[i][j];
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  Edgeo
procedure RetrieveEdge(Src, Dst: TBitmap; const Ope: TOperator);
var
    i, j, k, l: integer;
    LineS: array[0..2] of PByteArray;
    LineD: PByteArray;
    R, G, B, Edge: Byte;
    R1, G1, B1: integer;
    R2, G2, B2: integer;
    V, H: integer;
    wEdge: TWordWordArray;
    wMax: Word;
begin
    Dst.Width := Src.Width;
    Dst.Height := Dst.Height;

    //  Ɨpz̃TCY
    SetLength(wEdge, Src.Height, Src.Width);

    for i := 1 to Src.Height - 2 do
    begin
        for j := 1 to Src.Width - 2 do
        begin

            R1 := 0;
            G1 := 0;
            B1 := 0;
            R2 := 0;
            G2 := 0;
            B2 := 0;

            //  1se
            LineS[0] := Src.ScanLine[i + 0 - 1];
            LineS[1] := Src.ScanLine[i + 1 - 1];
            LineS[2] := Src.ScanLine[i + 2 - 1];

            for k := 0 to 2 do
            begin
                for l := 0 to 2 do
                begin
                    //  RGBlꂼo
                    R := LineS[l][(j + k - 1) * 3 + 2];
                    G := LineS[l][(j + k - 1) * 3 + 1];
                    B := LineS[l][(j + k - 1) * 3 + 0];

                    //  ̕ωo
                    Inc(R1, R * Ope[l, k]);
                    Inc(G1, G * Ope[l, k]);
                    Inc(B1, B * Ope[l, k]);

                    //  c̕ωo
                    Inc(R2, R * Ope[k, l]);
                    Inc(G2, G * Ope[k, l]);
                    Inc(B2, B * Ope[k, l]);
                end;
            end;

            V := Abs(R1) + Abs(G1) + Abs(B1);
            H := Abs(R2) + Abs(G2) + Abs(B2);

            //  傫̗p
            if (V >= H) then wEdge[i, j] := V else wEdge[i, j] := H; 
        end;
    end;

    //  Edge̋̍ől߂
    wMax := MaxValue(wEdge);

    //  Edge̋̍ől1/8臒lɂEdge`悷
    for i := 0 to Src.Height - 1 do
    begin
        //  1se
        LineD := Dst.ScanLine[i];

        for j := 0 to Src.Width - 1 do
        begin
            if (wEdge[i, j] * 8 > wMax) then Edge := 0 else Edge := 255;

            //  RGBlꂼꏑ
            LineD[j * 3 + 2] := Edge;
            LineD[j * 3 + 1] := Edge;
            LineD[j * 3 + 0] := Edge;
        end;
    end;
end;

//=============================================================================

//-----------------------------------------------------------------------------
//  DegreeRadionp
const
    PIK = PI / 1024;

//-----------------------------------------------------------------------------
type
    TRadianTable = array[0..1023] of Extended;

//-----------------------------------------------------------------------------
//  sin/cose[u(0..΃WA)
procedure MakeSinCosTable(var SinTable, CosTable: TRadianTable);
var
    i: integer;
begin
    //  Ă
    FillChar(SinTable, SizeOf(TRadianTable), 0);
    FillChar(CosTable, SizeOf(TRadianTable), 0);

    //  vZ
    for i := Low(TRadianTable) to High(TRadianTable) do
    begin
        SinCos(PIK * i, SinTable[i], CosTable[i]);
    end;
end;

//-----------------------------------------------------------------------------
type
    //THoughCounter = array[0..999] of array[0..1023] of Word;
    THoughCounter = array of array of Word;

//-----------------------------------------------------------------------------
//  Houghϊɂ钼̌o1(̊m)
procedure Hough1(var Counter: THoughCounter; var SinTable, CosTable: TRadianTable);
begin
    //  0łɂĂ͂
    SetLength(Counter, 1024, 1000);

    //  e[u쐬
    MakeSinCosTable(SinTable, CosTable);
end;

//-----------------------------------------------------------------------------
//  Houghϊɂ钼̌o2(Houghϊ)
procedure Hough2(Src: TBitmap; var Counter: THoughCounter; const SinTable, CosTable: TRadianTable);
var
    i, j, Theta, Rho: integer;
    Line: PByteArray;
    R: Byte;
begin
    for i := 0 to Src.Height - 1 do
    begin
        //  1se
        Line := Src.ScanLine[i];

        for j := 0 to Src.Width - 1 do
        begin
            //  RGBlꂼo
            R := Line[j * 3 + 2];
            //G := Line[j * 3 + 1];
            //B := Line[j * 3 + 0];

            //  ̃sNZ
            if (R < 128) then
            begin
                for Theta := Low(Counter) to High(Counter) do
                begin
                    Rho := Round(j * CosTable[Theta] + i * SinTable[Theta]);

                    if (Low(Counter[Theta]) <= Rho + 500) and (Rho + 500 <= High(Counter[Theta])) then
                        Inc(Counter[Theta][Rho + 500]);
                end;
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  Houghϊɂ钼̌o3
procedure Hough3(Src, Dst: TBitmap; var Counter: THoughCounter;
                const SinTable, CosTable: TRadianTable;
                const Count: integer);
var
    i, j, k, Theta, Rho: integer;
    CounterMax, ThetaMax, RhoMax: integer;
    x, y: integer;
begin
    //  Rs[
    if (Src <> Dst) then Dst.Assign(Src);

    //  Hough()tϊ̎s(o{)
    for k := 0 to Count - 1 do
    begin

        CounterMax := 0;
        ThetaMax := 0;
        RhoMax := 0;

        //  CounterőɂȂThetaMaxRhoMax߂
        for Theta := Low(Counter) to High(Counter) do
        begin
            for Rho := Low(Counter[Theta]) to High(Counter[Theta]) do
            begin
                if Counter[Theta][Rho] > CounterMax then
                begin
                    CounterMax := Counter[Theta][Rho];
                    ThetaMax := Theta;
                    RhoMax := Rho - 500;                    
                end;
            end;
        end;

        //  ThetaMax==0̎́A̐ɂȂAxςȂy`Ȃ
        if (ThetaMax <> 0) then
        begin
            //  xςy`
            for x := 0 to Src.Width - 1 do
            begin
                y := Round((RhoMax - x * CosTable[ThetaMax]) / SinTable[ThetaMax]);
                if (y < 0) or (Src.Height - 1 < y) then Continue;
                Src.Canvas.Pixels[x, y] := clRed;
            end;
        end;

        //  ThetaMax==512̎́A̐ɂȂAyςȂx`Ȃ
        if (ThetaMax <> 512) then
        begin
            //  yςx`
            for y := 0 to Src.Height - 1 do
            begin
                x := Round((RhoMax - y * SinTable[ThetaMax]) / CosTable[ThetaMax]);
                if (x < 0) or (Src.Width - 1 < x) then Continue;
                Src.Canvas.Pixels[x, y] := clRed;
            end;
        end;

        //  ThetaMaxRhoMaxCounterƂ̋ߖTCounter
        for i := -20 to 20 do
        begin
            for j := -10 to 10 do
            begin
                if (ThetaMax + i < 0) then Inc(ThetaMax, 1024);
                if (ThetaMax + i > 1023) then Inc(ThetaMax, - 1024);
                if (RhoMax + j < - 500) or (499 < RhoMax + j) then Continue;
                Counter[ThetaMax + i][RhoMax + 500 + j] := 0;
                //  RhoMax̃}CiX
                Counter[ThetaMax + i][- RhoMax + 500 + j] := 0;
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  _uobt@p̃rbg}bv쐬
    Bmp := TBitmap.Create;
    //  ScanLineg߂24bitɂĂ
    Bmp.PixelFormat := pf24bit;
    //  ̂ŃtHg𒲐
    Bmp.Canvas.Font.Assign(Self.Font);

    //  h~
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  _uobt@p̃rbg}bvj
    Bmp.Free;
end;

//-----------------------------------------------------------------------------
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    Pbox: TPaintBox;
begin
    //  LXgĂ
    Pbox := TPaintBox(Sender);

    //  ܂ɓhԂ
    Pbox.Canvas.FillRect(Pbox.ClientRect);

    //  ʕ\
    BitBlt(Pbox.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height,
            Bmp.Canvas.Handle, 0, 0, SRCCOPY);
end;

//-----------------------------------------------------------------------------
//  t@Cǂݍ
procedure TForm1.Button1Click(Sender: TObject);
begin
    if OpenDialog1.Execute then
    begin
        try
            Image1.Picture.Bitmap.LoadFromFile(OpenDialog1.FileName);
            Image1.Picture.Bitmap.PixelFormat := pf24bit;

            //if Image1.Picture.Bitmap.Width > 400 then Image1.Picture.Bitmap.Width := 400;
            //if Image1.Picture.Bitmap.Height > 400 then Image1.Picture.Bitmap.Height := 400;

            Bmp.Assign(Image1.Picture.Bitmap);
            PaintBox1.Repaint();
        except

        end;
    end;
end;

//-----------------------------------------------------------------------------
//  Nbv{[h炩ǂݍ
procedure TForm1.Button5Click(Sender: TObject);
begin
    if Clipboard.HasFormat(cf_BitMap) then
    begin
        Image1.Picture.Bitmap.LoadFromClipBoardFormat(cf_BitMap, ClipBoard.GetAsHandle(cf_Bitmap), 0);
        Bmp.Assign(Image1.Picture.Bitmap);
        PaintBox1.Repaint();
    end;
end;

//-----------------------------------------------------------------------------
//  l
procedure TForm1.Button2Click(Sender: TObject);
begin
    //  ǂݍ܂Ă
    if Image1.Picture.Bitmap.Width = 0 then Exit;

    Screen.Cursor := crHourGlass;

    //  摜̔l
    Monochromize(Image1.Picture.Bitmap, Bmp);

    Screen.Cursor := crDefault;

    //  ĕ`
    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  Edgeo
procedure TForm1.Button3Click(Sender: TObject);
begin
    //  ǂݍ܂Ă
    if Image1.Picture.Bitmap.Width = 0 then Exit;

    Screen.Cursor := crHourGlass;

    //  IWiǂݍ
    Bmp.Assign(Image1.Picture.Bitmap);

    //  摜g
    Expand(Bmp);

    //  Edgeo
    //RetrieveEdge(Bmp, Bmp, Roberts);
    RetrieveEdge(Bmp, Bmp, Prewitt);
    //RetrieveEdge(Bmp, Bmp, Sobel);

    Screen.Cursor := crDefault;

    //  ĕ`
    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  Houghϊ
procedure TForm1.Button4Click(Sender: TObject);
var
    Counter: THoughCounter;
    SinTable, CosTable: TRadianTable;
begin
    //  ǂݍ܂Ă
    if Image1.Picture.Bitmap.Width = 0 then Exit;

    Screen.Cursor := crHourGlass;

    //  IWiǂݍ
    //Bmp.Assign(Image1.Picture.Bitmap);

    Hough1(Counter, SinTable, CosTable);
    Hough2(Bmp, Counter, SinTable, CosTable);
    Hough3(Bmp, Bmp, Counter, SinTable, CosTable, 10);

    Screen.Cursor := crDefault;

    //  ĕ`
    PaintBox1.Repaint();
end;

end.
